<template>
  <v-data-table
    :headers="headers"
    :items="dispData"
    :items-per-page="30"
    dense
    class="elevation-1"
  >
    <template v-slot:top>
      <v-toolbar flat dense short>
        <v-toolbar-title>給油</v-toolbar-title>
        <v-divider class="mx-4" inset vertical />
        <v-spacer />
        <v-switch label="縮小表示" class="mx-4" v-model="min" />
        <v-dialog v-model="dialog">
          <template v-slot:activator="{ on, attrs }">
            <v-btn color="primary" small v-bind="attrs" v-on="on"> 新規 </v-btn>
          </template>
          <v-card>
            <v-card-text>
              <v-container>
                <v-row>
                  <inline-date-picker
                    title="給油日"
                    v-model="editedItem.gasDate"
                  />
                  <v-text-field
                    v-model.number="editedItem.odo"
                    :rules="odoRules"
                    label="走行距離"
                    required
                    type="number"
                    dense
                  />
                  <v-text-field
                    v-model.number="editedItem.quantity"
                    :rules="quantityRules"
                    label="量"
                    required
                    type="number"
                    dense
                  />
                  <v-text-field
                    v-model.number="editedItem.cost"
                    :rules="costRules"
                    label="価格"
                    type="number"
                    dense
                  />
                  <v-combobox
                    v-model="editedItem.shop"
                    :items="selects.shops"
                    label="ショップ"
                    dense
                  />
                  <v-checkbox v-model="editedItem.isFull" label="満タン" required dense />
                </v-row>
              </v-container>
            </v-card-text>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue darken-1" text @click="close"> Cancel </v-btn>
              <v-btn color="blue darken-1" text @click="save"> Save </v-btn>
            </v-card-actions>
          </v-card>
        </v-dialog>
        <v-dialog v-model="dialogDelete" max-width="500px">
          <v-card>
            <v-card-title class="text-h5">削除しますか？</v-card-title>
            <v-card-actions>
              <v-spacer></v-spacer>
              <v-btn color="blue darken-1" text @click="closeDelete"
                >Cancel</v-btn
              >
              <v-btn color="blue darken-1" text @click="deleteItemConfirm"
                >OK</v-btn
              >
              <v-spacer></v-spacer>
            </v-card-actions>
          </v-card>
        </v-dialog>
      </v-toolbar>
    </template>
    <template v-slot:[`item.actions`]="{ item }">
      <v-icon small class="mr-2" @click="editItem(item)"> mdi-pencil </v-icon>
      <v-icon small @click="deleteItem(item)"> mdi-delete </v-icon>
    </template>
  </v-data-table>
</template>

<script>
import InlineDatePicker from "~/components/InlineDatePicker.vue";
export default {
  components: { InlineDatePicker },

  mounted: function () {
    if (localStorage.getItem("gasData")) {
      try {
        this.gasData = JSON.parse(localStorage.getItem("gasData"));
      } catch (e) {
        localStorage.removeItem("gasData");
      }
    }
  },

  data: () => ({
    min: true,
    dialog: false,
    dialogDelete: false,
    selects: {
      shops: ["ENEOS", "出光", "Mobil", "Cosmo", "その他"],
    },
    gasData: [],
    editedIndex: -1,
    editedItem: {
      gasDate: new Date(Date.now() - new Date().getTimezoneOffset() * 60000)
        .toISOString()
        .substr(0, 10),
      odo: "",
      quantity: "",
      cost: "",
      shop: "",
      isFull: true,
    },
    defaultItem: {
      gasDate: new Date(Date.now() - new Date().getTimezoneOffset() * 60000)
        .toISOString()
        .substr(0, 10),
      odo: "",
      quantity: "",
      cost: "",
      shop: "",
      isFull: true,
    },
    odoRules: [(v) => !!v || "走行距離は必須です"],
    quantityRules: [(v) => !!v || "量は必須です"],
    costRules: [(v) => /^[0-9]*$/.test(v) || "金額は整数です"],
  }),

  computed: {
    dispData: function () {
      var disp = [];
      var preodo = 0;
      var quantity = 0;
      this.gasData.forEach((item, idx) => {
        var strFull = "";
        var kmpl = "-";
        let yenpl = Math.round(item["cost"] / item["quantity"]);
        quantity = quantity + item["quantity"];
        if (item["isFull"]) {
          strFull = "✓";
          kmpl = (item["odo"] - preodo) / quantity;
          kmpl = Math.round(kmpl * 10) / 10;
          preodo = item["odo"];
          quantity = 0;
        }
        disp.push({
          gasDate: item["gasDate"],
          odo: item["odo"],
          quantity: item["quantity"],
          cost: item["cost"],
          yenpl: yenpl,
          shop: item["shop"],
          isFull: strFull,
          kmpl: kmpl,
          index: idx,
        });
      });
      return disp.reverse();
    },
    headers() {
      if (this.min) {
        return [
          { text: "走行距離", value: "odo" },
          { text: "量", value: "quantity" },
          { text: "燃費", value: "kmpl" },
        ];
      } else {
        return [
          { text: "給油日", value: "gasDate" },
          { text: "走行距離", value: "odo" },
          { text: "量", value: "quantity" },
          { text: "費用", value: "cost" },
          { text: "円/L", value: "yenpl" },
          { text: "ショップ", value: "shop" },
          { text: "燃費", value: "kmpl" },
          { text: "操作", value: "actions", sortable: false },
        ];
      }
    },
  },

  watch: {
    dialog(val) {
      val || this.close();
    },
    dialogDelete(val) {
      val || this.closeDelete();
    },
  },

  created() {
    this.initialize();
  },

  methods: {
    initialize() {
      this.gasData = [];
    },

    editItem(item) {
      this.editedIndex = item.index; //this.gasData.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialog = true;
    },

    deleteItem(item) {
      this.editedIndex = item.index; //this.gasData.indexOf(item);
      this.editedItem = Object.assign({}, item);
      this.dialogDelete = true;
    },

    deleteItemConfirm() {
      this.gasData.splice(this.editedIndex, 1);
      const parsed = JSON.stringify(this.gasData);
      localStorage.setItem("gasData", parsed);
      this.closeDelete();
    },

    close() {
      this.dialog = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    closeDelete() {
      this.dialogDelete = false;
      this.$nextTick(() => {
        this.editedItem = Object.assign({}, this.defaultItem);
        this.editedIndex = -1;
      });
    },

    save() {
      if (this.editedIndex > -1) {
        Object.assign(this.gasData[this.editedIndex], this.editedItem);
      } else {
        this.gasData.push(this.editedItem);
      }
      const parsed = JSON.stringify(this.gasData);
      localStorage.setItem("gasData", parsed);
      this.close();
    },
  },
};
</script>